﻿using System;
using System.Collections.Generic;
using System.Windows.Forms;
using Infragistics.Win;
using Infragistics.Win.UltraWinGrid;

namespace ultragrid_copypasterow
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            ultraGrid1.DataSource = Class2.MakeData();

            ultraGrid1.DisplayLayout.Override.AllowMultiCellOperations = AllowMultiCellOperation.All;
            ultraGrid1.DisplayLayout.Override.RowSelectors = DefaultableBoolean.True;
            ultraGrid1.DisplayLayout.Override.CellClickAction = CellClickAction.RowSelect;

            ultraGrid1.DisplayLayout.Bands[0].Columns[1].CellActivation = Activation.NoEdit;
        }

        private void ultraGrid1_Error(object sender, ErrorEventArgs e)
        {
            if (e.ErrorType == ErrorType.MultiCellOperation)
            {
                if (e.MultiCellOperationErrorInfo.Operation == MultiCellOperation.Paste)
                {
                    e.Cancel = true;
                    e.MultiCellOperationErrorInfo.Action = MultiCellOperationErrorInfo.ErrorAction.Continue;
                }
            }
        }
    }

    public class Class2
    {
        public string name { get; set; }
        public int value { get; set; }
        public DateTime date { get; set; }

        public static List<Class2> MakeData()
        {
            List<Class2> c = new List<Class2>();

            for (int i = 1; i <= 10; i++)
            {
                Class2 cc = new Class2();
                cc.name = "Name" + i;
                cc.value = i;
                cc.date = DateTime.Now.AddDays(i);

                c.Add(cc);
            }

            return c;
        }
    }
}